<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form ref="formRef" :model="formData" :rules="formRules" label-width="100px" v-loading="formLoading">
      <el-form-item :label="t('bigBrother.displayId')" prop="displayId">
        <el-input v-model="formData.displayId" :placeholder="t('bigBrother.placeDisplayId')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.uid')" prop="userIdStr">
        <el-input v-model="formData.userIdStr" :placeholder="t('bigBrother.placeUid')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.nickname')" prop="nickname">
        <el-input v-model="formData.nickname" :placeholder="t('bigBrother.placeNickname')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.level')" prop="level">
        <el-input v-model="formData.level" :placeholder="t('bigBrother.placeLevel')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.hostCoins')" prop="hostcoins">
        <el-input v-model="formData.hostcoins" :placeholder="t('bigBrother.placeHostCoins')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.followerCount')" prop="followerCount">
        <el-input v-model="formData.followerCount" :placeholder="t('bigBrother.placeFollowerCount')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.followingCount')" prop="followingCount">
        <el-input v-model="formData.followingCount" :placeholder="t('bigBrother.placeFollowingCount')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.region')" prop="region">
        <el-input v-model="formData.region" :placeholder="t('bigBrother.placeRegion')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.historicHighCoins')" prop="historicHighCoins">
        <el-input v-model="formData.historicHighCoins" :placeholder="t('bigBrother.placeHistoricHighCoins')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.totalGiftCoins')" prop="totalGiftCoins">
        <el-input v-model="formData.totalGiftCoins" :placeholder="t('bigBrother.placeTotalGiftCoins')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.hostDisplayId')" prop="hostDisplayId">
        <el-input v-model="formData.hostDisplayId" :placeholder="t('bigBrother.placeHostDisplayId')" />
      </el-form-item>
      <el-form-item :label="t('bigBrother.ownerId')" prop="ownerId">
        <el-input v-model="formData.ownerId" :placeholder="t('bigBrother.placeOwnerId')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { BigBrotherApi, BigBrotherVO } from '@/api/server/bigbrother'

/** 大哥数据 表单 */
defineOptions({ name: 'BigBrotherForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  displayId: undefined,
  userIdStr: undefined,
  nickname: undefined,
  level: undefined,
  hostcoins: undefined,
  followerCount: undefined,
  followingCount: undefined,
  region: undefined,
  historicHighCoins: undefined,
  totalGiftCoins: undefined,
  hostDisplayId: undefined,
  ownerId: undefined
})
const formRules = reactive({
  displayId: [{ required: true, message: t('bigBrother.displayIdRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await BigBrotherApi.getBigBrother(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as BigBrotherVO
    if (formType.value === 'create') {
      await BigBrotherApi.createBigBrother(data)
      message.success(t('common.createSuccess'))
    } else {
      await BigBrotherApi.updateBigBrother(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    displayId: undefined,
    userIdStr: undefined,
    nickname: undefined,
    level: undefined,
    hostcoins: undefined,
    followerCount: undefined,
    followingCount: undefined,
    region: undefined,
    historicHighCoins: undefined,
    totalGiftCoins: undefined,
    hostDisplayId: undefined,
    ownerId: undefined
  }
  formRef.value?.resetFields()
}
</script>